(* 
 * Copyright (c) 2001, 2002 The University of Wroclaw.
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Id: gontbind.mli,v 1.4 2002/02/16 12:09:08 malekith Exp $
 *
 * Module interface: Gontbind
 * Description: Interface to symbol binder. (see .ml file for more info)
 *)

open Gonttree

type ctx

(* Return initial binding context for named module. *)
val init_bind : (* module name *) string -> (* iface *) bool -> ctx

(* Modify decl in place, adding symbol entries to Ref terms. This mustn't be
 * called more then once in a top level declaration (i.e. don't call it for 
 * nested functions). *)
val bind : ctx -> decl -> ctx

(* Return list of symbols, at given scoping (function) level, that needs 
 * to put into the closure because they are referenced in stmts. *)
val closure : int -> stmt -> (bool * symbol list)

(* Save module interface. *)
val finalize_module : out_channel -> ctx -> unit
;;
